--- asterisk/channel.c	7 Nov 2003 03:48:03 -0000	1.70
+++ asterisk/channel.c	7 Jan 2004 15:16:59 -0000
@@ -78,17 +78,67 @@
 	if (!chan->whentohangup) return 0;
 	time(&myt); /* get current time */
 	  /* return, if not yet */
-	if (chan->whentohangup > myt) return 0;
-	chan->_softhangup |= AST_SOFTHANGUP_TIMEOUT;
-	return 1;
+	if ((chan->whentohangup == myt+40) && (chan->rings < 50)) { 
+            ast_log(LOG_NOTICE,"Faltan 40 segundos para cortar\n");
+            chan->rings=50;
+            return 0;
+	} else if ((chan->whentohangup == myt+39) && (chan->rings >= 50)) { 
+            ast_log(LOG_NOTICE,"Apago sonidos\n");
+            chan->rings=100;
+            return 0;
+	} else if ((chan->whentohangup == myt+30) && (chan->rings < 50)) { 
+            ast_log(LOG_NOTICE,"Faltan 30 segundos para cortar\n");
+            chan->rings=50;
+            return 0;
+	} else if ((chan->whentohangup == myt+29) && (chan->rings >= 50)) { 
+            ast_log(LOG_NOTICE,"Apago sonidos\n");
+            chan->rings=100;
+            return 0;
+	} else if ((chan->whentohangup == myt+20) && (chan->rings < 50)) { 
+            ast_log(LOG_NOTICE,"Faltan 20 segundos para cortar\n");
+            chan->rings=50;
+            return 0;
+	} else if ((chan->whentohangup == myt+19) && (chan->rings >= 50)) { 
+            ast_log(LOG_NOTICE,"Apago sonidos\n");
+            chan->rings=100;
+            return 0;
+	} else if ((chan->whentohangup == myt+10) && (chan->rings < 50)) { 
+            ast_log(LOG_NOTICE,"Faltan 10 segundos para cortar\n");
+            chan->rings=50;
+            return 0;
+	} else if ((chan->whentohangup == myt+9) && (chan->rings >= 50)) { 
+            ast_log(LOG_NOTICE,"Apago sonidos\n");
+            chan->rings=100;
+            return 0;
+        } else if (chan->whentohangup > myt) { 
+            return 0; 
+        } else {
+          chan->rings=100;
+          chan->_softhangup |= AST_SOFTHANGUP_TIMEOUT;
+	  return 1;
+       }
 }
 
 static int ast_check_hangup_locked(struct ast_channel *chan)
 {
 	int res;
+ 
 	ast_mutex_lock(&chan->lock);
 	res = ast_check_hangup(chan);
 	ast_mutex_unlock(&chan->lock);
+
+	if (chan->rings == 100 ) {
+          ast_log(LOG_NOTICE,"Playtones STOP %d\n",chan->rings);
+   	  ast_playtones_stop(chan);
+          chan->rings=0;
+        }
+
+	if (chan->rings == 50) {
+	  ast_log(LOG_NOTICE,"Playtones START %d\n",chan->rings);
+   	  ast_playtones_start(chan,7110,"440/100,600/100,0/200", 0);
+          chan->rings++;
+        } 
+
 	return res;
 }
